; 
; Keyboard scancode: displays the code returned by key pressed
; 

INCLUDE \masm32\include\masm32rt.inc

Scan_code    PROTO 



; 
; Data Area
; 

.DATA

;        code_entered dw 0
;        pcode        dd code_entered

.DATA?


        
        stdin   dd ?
        howmany dd ?
        buffer  INPUT_RECORD <>

; 
; Code Area
; 

.CODE

_main   PROC

        invoke GetStdHandle,STD_INPUT_HANDLE
        mov stdin,eax

;Scan the keyboard for key pressed

scan_cycle:

        INVOKE  Scan_code

        cls
        xor eax, eax
        mov ax, buffer.KeyEvent.wVirtualKeyCode

        switch eax
          case VK_ESCAPE 
            jmp finish
          case VK_F1 
            print "You have pressed F1",13,10
                        
          case VK_END 
            print "You have pressed Key END",13,10
            
          case VK_HOME 
            print "You have pressed Key HOME",13,10
                          
          case VK_DOWN 
            print "You have pressed Arrow Key DOWN",13,10
                      
          case VK_UP 
            print "You have pressed Arrow Key UP",13,10
            
          case VK_LEFT 
            print "You have pressed Arrow Key LEFT",13,10
             
          case VK_RIGHT 
            print "You have pressed Arrow Key RIGHT",13,10
                                                 
          default 
            print "Key not managed"
         
        endsw

       

        jmp     scan_cycle

finish  :

        loc 15,10

        print "You have pressed the ESCAPE key - The program terminates",13,10
        inkey
          
end_scan:       
        invoke ExitProcess,0

_main   ENDP



; 
; Scancode Routine
; 

Scan_code PROC  

;Returns: key code in buffer.KeyEvent.wVirtualKeyCode 


        loc 25,12
        print "Press a key or ESC to close: ",13,10

again:  invoke ReadConsoleInput,stdin,offset buffer,1,offset howmany
        cmp buffer.EventType,KEY_EVENT
        jnz again

        cmp buffer.KeyEvent.bKeyDown,0
        jz again

finish: 
        
        ret 

Scan_code ENDP

; 
        END     _main
; 